// FileExceptionTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FileExceptionTest.h"
#include "FileExceptionTestDlg.h"

#include "about.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileExceptionTestDlg dialog

CFileExceptionTestDlg::CFileExceptionTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileExceptionTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileExceptionTestDlg)
	m_strFileExceptionDescription = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFileExceptionTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileExceptionTestDlg)
	DDX_Control(pDX, IDC_COMBO1, m_cboFileExceptions);
	DDX_Text(pDX, IDC_EDIT1, m_strFileExceptionDescription);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFileExceptionTestDlg, CDialog)
	//{{AFX_MSG_MAP(CFileExceptionTestDlg)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(ID_APP_ABOUT, OnAbout)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileExceptionTestDlg message handlers

BOOL CFileExceptionTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	static struct
	{
	int iException;
	char szException[25];
	} FILE_EXCEPTIONS[] = {
	CFileException::none, "None",
	CFileException::generic, "Generic",
	CFileException::fileNotFound, "File Not Found",
	CFileException::badPath, "Bad Path",
	CFileException::tooManyOpenFiles, "Too many open files",
	CFileException::accessDenied, "Access denied",
	CFileException::invalidFile, "Invalid File",
	CFileException::removeCurrentDir, "Remove Current Dir",
	CFileException::directoryFull, "Directory Full",
	CFileException::badSeek, "Bad Seek",
	CFileException::hardIO, "Hard I/O",
	CFileException::sharingViolation, "Sharing Violation",
	CFileException::lockViolation, "Lock Violation",
	CFileException::diskFull, "Disk Full",
	CFileException::endOfFile, "End of File",
	};

	int iIndex;
	for (int i = 0; i < sizeof FILE_EXCEPTIONS / 
	 sizeof FILE_EXCEPTIONS[0]; i++)
	{
	 iIndex = m_cboFileExceptions.AddString(
	  FILE_EXCEPTIONS[i].szException);
	 m_cboFileExceptions.SetItemData(iIndex,
	  (DWORD)FILE_EXCEPTIONS[i].iException);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFileExceptionTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFileExceptionTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFileExceptionTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFileExceptionTestDlg::OnAbout()
{
 CAboutDlg().DoModal();
}

void CFileExceptionTestDlg::OnSelchangeCombo1()
{
 try
 {	
  DisplayFileException();
  AfxMessageBox("We should never get here!");
 }
 catch(CFileException* pe)
 {
  char sz[255];
  pe->GetErrorMessage(sz, 255);
		
  m_strFileExceptionDescription = sz;
  UpdateData(FALSE);

  pe->Delete();
 }
}

void CFileExceptionTestDlg::DisplayFileException()
{
 int iIndex;
 if (CB_ERR != (iIndex =
  m_cboFileExceptions.GetCurSel()))
 {
 int iFileException =
  m_cboFileExceptions.GetItemData(iIndex);
 throw new CFileException(iFileException);
 }
}
